use std::{
    fs::File,
    io::{Read, Result},
};

fn main() -> Result<()> {
    let mut file = File::open("./data").expect("Data file not found");
    let mut content = String::new();
    file.read_to_string(&mut content)?;
    let data = content
        .split("\n")
        .collect::<Vec<&str>>()
        .iter()
        .map(|line| {
            line.split(",")
                .map(|x| {
                    x.split("-")
                        .filter_map(|x| x.parse::<i32>().ok())
                        .collect::<Vec<i32>>()
                })
                .collect::<Vec<Vec<i32>>>()
        })
        .collect::<Vec<Vec<Vec<i32>>>>()
        .iter()
        .map(|x| (x[0].to_owned(), x[1].to_owned()))
        .collect::<Vec<(Vec<i32>, Vec<i32>)>>();
    // Part 1
    let containig_pairs: Vec<&(Vec<i32>, Vec<i32>)> = data
        .iter()
        .filter(|(x, y)| {
            let ll = &x[0];
            let lr = &x[1];
            let rl = &y[0];
            let rr = &y[1];
            ll >= rl && lr <= rr || rl >= ll && rr <= lr
        })
        .collect();
    println!("data len: {:?}", data.len());
    println!("containig pairs: {:?}", containig_pairs.len());

    // Part 2
    let overlaping: Vec<&(Vec<i32>, Vec<i32>)> = data
        .iter()
        .filter(|(x, y)| {
            let ll = &x[0];
            let lr = &x[1];
            let rl = &y[0];
            let rr = &y[1];
            lr >= rl && lr <= rr || rr >= ll && rr <= lr
        })
        .collect();

    println!("overlaping: {:?}", overlaping.len());

    Ok(())
}
